unit aaaUnit1;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, LResources, Forms, Controls, Graphics, Dialogs, ExtCtrls,contnrs,LCLIntf;

type

{ TPaintControl }

  TPaint2oBj = class
    x,y,w,h:Integer;
  end;
  TPaintControl=class (TCustomControl)

  public
    ismouseup:Boolean;
    objlist:TObjectList;
    objsel:TPaint2oBj;
    constructor Create(AOwner:TComponent);override;
    procedure addobj(x,y,w,h:Integer);
    procedure MouseDown(Button:TMouseButton;Shift: TShiftState; X,Y: Integer);  override;
    procedure MouseMove(Shift: TShiftState; X,Y: Integer);  override;
    procedure MouseUp(Button: TMouseButton; Shift:TShiftState; X,Y:Integer); override;

    procedure Paint; override;
  end;


  { TForm1 }

  TForm1 = class(TForm)
    Panel1: TPanel;
    Panel2: TPanel;
    Panel3: TPanel;
    Panel4: TPanel;
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure FormPaint(Sender: TObject);
    procedure FormResize(Sender: TObject);
    procedure Panel1MouseDown(Sender: TOBject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);

  private
    { private declarations }
    PainterControl: TPaintControl;
  public
    { public declarations }
  end;

var
  Form1: TForm1;
  mx, my,sx,sy:integer;
  Buffer,buffer2,buffer3,buffer4:TBitmap;
  t:Boolean = False;
  ob:TPaint2oBj;

implementation { TForm1 }

procedure TPaintControl.addobj(x,y,w,h:Integer);
begin
  ob:=TPaint2oBj.Create;
  ob.x:=x;   ob.y:=y;   ob.h:=h;   ob.w:=w;
  objlist.add(ob);
  objsel:=TPaint2oBj(objlist.Items[objlist.Count-1]);
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  PainterControl := TPaintControl.Create(Panel1);
  PainterControl.Align := alClient;
  PainterControl.Parent := panel1;
  PainterControl.DoubleBuffered := True;
  PainterControl.ismouseup:=False;
  Buffer:=TBitmap.create; Buffer2:=TBitmap.create; Buffer3:=TBitmap.create;
  buffer4:=TBitmap.Create;

  mx:=200;my:=200; sx:=0; sy:=0;
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
  PainterControl.Free;
  Buffer.free;
  buffer2.free;
  buffer3.free;
  buffer4.free;
end;

procedure TForm1.FormPaint(Sender: TObject);
begin
  //PainterControl.Invalidate;
end;

// diese procedure soll denn komplenten buffer
// in buffer4 kopieren damit ich buffer cleraren kann
// und anschliessend sichere ich es zurueck !
// die beschrieben fehler treten nur auf wenn ich in buffer4 schreiben moechte
procedure TForm1.FormResize(Sender: TObject);
var
  arect:Trect;
begin
  if Assigned(Buffer) then begin
    t:=true;

    Buffer4.Width:=panel1.Width; Buffer4.Height:=panel1.Height;
    buffer4.Canvas.FillRect(0,0,buffer4.Width,buffer4.Height);
    arect.left:=0; aRect.top:=0; arect.Right:=buffer4.Width; arect.Bottom:=buffer4.Height;
    buffer4.canvas.CopyRect(aRect,buffer.canvas,aRect);



    Buffer.Width:=panel1.Width;Buffer.Height:=panel1.Height; Buffer2.Width:=panel1.Width;Buffer2.Height:=panel1.Height;
    Buffer3.Width:=panel1.Width;Buffer3.Height:=panel1.Height;

    arect.left:=0; aRect.top:=0; arect.Bottom:=panel1.Height; arect.Right:=panel1.Width;



    buffer.canvas.FillRect(arect); buffer3.canvas.FillRect(arect); buffer2.canvas.FillRect(arect);

    arect.left:=0; aRect.top:=0; arect.Right:=panel1.Width; arect.Bottom:=panel1.Height;

    buffer.canvas.CopyRect(aRect,buffer4.canvas,aRect);
    mx:=0; my:=0; sx:=0; sy:=0;
    t:=false;


  end;
end;

procedure TForm1.Panel1MouseDown(Sender: TOBject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin

end;

{ TPaintControl }
constructor TPaintControl.Create(AOwner:TComponent);
begin
  inherited Create(AOwner);
  objlist:=TObjectList.Create;
  objsel:=TPaint2oBj.Create;
  objsel.x:=0; objsel.y:=0; objsel.w:=Width; objsel.h:=Height;
end;
procedure TPaintControl.MouseDown(Button:TMouseButton;Shift: TShiftState; X,Y: Integer);
var
  i:Integer;
  r,outr,r1:TRect;
begin
    inherited MouseDown(Button,Shift,X,Y);
  if t = False then begin
    if ssRight in Shift then begin
      mx:=x; my:=y;
      for i:=0 to objlist.count-1 do begin
        r.left:=TPaint2oBj(objlist[i]).x;
        r.top:=TPaint2oBj(objlist[i]).y;
        r.Right:=TPaint2oBj(objlist[i]).w;
        r.Bottom:=TPaint2oBj(objlist[i]).h;

        if PtInRect(r,Point(x,y)) = True then begin
          objsel:=TPaint2oBj(objlist[i]);
         end;
      end;
      Buffer.Canvas.Pen.style:=psClear;
      Buffer.Canvas.Rectangle(objsel.x,objsel.y,objsel.w+1,objsel.h+1);
    end;

    if (ssLeft in Shift) and (ssRight in Shift = false) then begin
      addobj(x,y,x+20,y+20);
      mx:=x; my:=y;
    end;
  end;
end;

procedure TPaintControl.MouseMove(Shift: TShiftState; X, Y: Integer);
begin
  if (t = false) and (ismouseup = false) then begin
    sx:=x; sy:=y;

    if (ssRight in Shift) or (ssLeft in Shift) then begin
      if objsel <> NIL then begin
        if ssCtrl in Shift then begin
          objsel.w:=x+(objsel.w-objsel.x); objsel.h:=y+(objsel.h-objsel.y);
          objsel.x:=x; objsel.y:=y;

        end
        else begin
          objsel.w:=x;
          objsel.h:=y;
        end;
        
        Screen.Forms[0].Caption:=IntTostr(objsel.x) + '\'+ IntTostr(objsel.y) + '\' + IntTostr(objsel.w) + '\' + IntTostr(objsel.h);

      end;
      inherited MouseMove(Shift, X, Y);
      invalidate;
    end;

  end;
end;

procedure TPaintControl.MouseUp(Button: TMouseButton; Shift:TShiftState; X,Y:Integer);
begin
  if t = false then begin
    inherited MouseUp(button,Shift, X, Y);
    ismouseup:=True;
    Invalidate
  end;
end;

procedure TPaintControl.Paint;
var
  r1:TRect;
begin
  if (t = false) and (objsel <> NIL ) then begin
    mx:=objsel.x;
    my:=objsel.y;
    sx:=objsel.w;
    sy:=objsel.h;
    inherited Paint;
    // sobalt die maustaste gedruckt wird bzw. wurde
    // wird der inhalt von buffer2 nach buffer kopiert(um ihn zu fixieren)
    if (ismouseup = true) then begin
      ismouseup:=false;
      r1.left:=mx;    r1.top:=my;
      // damit ich auch den rechten unt unteren rand
      // vom viereck erhalte muss ich hier die
      // alte position +1  nehmen(jeweils)
      r1.Right:=sx+1; r1.Bottom:=sy+1;

      // damit das viereck dauerhaft wird
      // wird es auf buffer kopiert !
      buffer.canvas.copyrect(r1,buffer2.canvas,r1);
    end;

     // damit ich was zu sehen bekomme wird das komplete
     // buffer nach buffer3 kopiert(weil ich kann ja buffer nicht immer andern)
     r1.left:=0; r1.top:=0; r1.Right:=Width; r1.Bottom:=Height;
     buffer3.canvas.copyrect(r1,buffer.canvas,r1);

    with Buffer2.Canvas do begin
      // um die alten recht ecke zu vermeiden
     // wird hier ein groeses viereck gezogen
      Brush.Style:=bsSolid;
      Brush.Color:=clWhite;
      Rectangle(0,0,Width,Height);


      Brush.color:=clRed;
      Brush.style:=bsSolid;
      Pen.Style:=psSolid;
      Pen.color:=clYellow;
     // das eigentliche viereck wird gezeichnet
      Rectangle(objsel.x,objsel.y,objsel.w,objsel.h);
      // buffer2 wird anschliend nach buffer3 kopiert aber nur den teil
     // der sich geandert hat
      buffer3.canvas.copyrect(rect(mx,my,sx+1,sy+1),buffer2.canvas,rect(mx,my,sx+1,sy+1));
      // um es zu sehen wird der buffer komplet nach canvas(von form1 kopiert)
      Canvas.Draw(0,0,Buffer3);
  end;
end;

end;

initialization
  {$I aaaUnit1.lrs}

end.

